#ifndef PKGLIB_RAPTHEADER_H
#define PKGLIB_RAPTHEADER_H

#include <vector>
#include <string>

#include "rapttypes.h"

#include <rpmtypes.h>
#include <rpmtag.h>
#include <rpmcli.h>

using std::vector;
using std::string;

class raptHeader
{
   private:
   Header Hdr;

   public:
   bool hasTag(rpmTag tag);
   bool getTag(rpmTag tag, uint32_t &data);
   bool getTag(rpmTag tag, string &data, bool raw = false);
   bool getTag(rpmTag tag, vector<uint32_t> &data);
   bool getTag(rpmTag tag, vector<string> &data, bool raw = false);
   string format(const string fmt);

   raptHeader(Header hdr);
   ~raptHeader();
};

#endif /* _PKGLIB_RAPTHEADER_H */

// vim:sts=3:sw=3
