// -*- mode: c++; mode: fold -*-
// Description								/*{{{*/
// $Id$
/* ######################################################################

   pkgRPMCfgBackup - TODO: Summary
 
   TODO: Description

   AUTHOR: David Salvador Pinheiro <david.pinheiro@caixamagica.pt>

   ##################################################################### */
									/*}}}*/
// Include Files							/*{{{*/
#ifdef __GNUG__
#pragma implementation "apt-pkg/rpmcfgbackup.h"
#endif

#include <apt-pkg/rpmcfgbackup.h>
#include <apt-pkg/fileutl.h>

#include <apt-pkg/tar.h>
#include <apt-pkg/configuration.h>

#include "rapttypes.h"
#include <rpmdb.h>

#include <fcntl.h>
#include <unistd.h>
#include <sstream>
#include <iostream>
#include "config.h"
#include "raptheader.h"
									/*}}}*/

pkgRPMCfgBackup::pkgRPMCfgBackup(const char *DBRootDir)
{
}

pkgRPMCfgBackup::~pkgRPMCfgBackup()
{
}

/*
string pkgRPMCfgBackup::FormatFN(const char *pkgName,int TID, const char *pkgVersion, const char *pkgRelease)
{   
   ostringstream FN;
   FN << pkgName <<"-cfg" << TID << "-"<< pkgVersion << "-" << pkgRelease <<".tar.bz2";
   return FN.str();
}
bool pkgRPMCfgBackup::Create(const char *pkgName,int TID)
{
   vector<string> FileList;
   string FileName;   
   string pkgVersion;
   string pkgRelease;
   
   if(GetCfgFileList(pkgName,FileList, pkgVersion, pkgRelease) == false)
      return false;

   if(FileList.empty())
      return false;

   string Dir = _config->FindDir("Dir::Cache::pkgcfg");
   if(FileExists(Dir) == false)
   {
      if( mkdir(Dir.c_str(),0644) == -1)
	 return false;
   }

   FileName = flCombine(Dir,FormatFN(pkgName,TID,pkgVersion.c_str(),pkgRelease.c_str()));
   BckFileList.push_back(FileName);

   return Tar::Create(FileName.c_str(),FileList,Tar::BZ2,NULL,NULL);
}

bool pkgRPMCfgBackup::Restore(const char *pkgName,int TID)
{
   bool Ret;
   string pkgVersion = " ";
   string pkgRelease = " ";
   string CWD = SafeGetCWD();
   string Dir = _config->FindDir("Dir::Cache::pkgcfg");
   string TarFile = flCombine(Dir,FormatFN(pkgName,TID,pkgVersion.c_str(),pkgRelease.c_str()));

   chdir ("/");
   if(FileExists(TarFile) == false)
      return false;

   Ret = Tar::Extract(TarFile.c_str(),Tar::BZ2, NULL, NULL);
   chdir(CWD.c_str());

   return Ret;
}
*/

bool pkgRPMCfgBackup::GetCfgFileList(const char *pkgName,vector<string> &FileList, string &pkgVersion, string &pkgRelease)
{   
   rpmdb DB;
   int Rc = 0;
   
   DB = NULL;
   
   rpmReadConfigFiles(NULL,NULL);
   Rc = rpmdbOpen(NULL,&DB,O_RDONLY,0644);
   
   if(Rc)
      return false;

   if(DB == NULL)
      return false;
   
   Header h;
   raptHeader header(h);
   vector<string> FileNames;
   vector<string> DirNames;
   int CountF = 0;
   int CountD = 0;
   vector<uint32_t> DirIndexes;
   vector<uint32_t> FileFlags; 

   string S;
   rpmmi MI;
   
   MI = rpmmiInit(DB, RPMTAG_NAME, pkgName,0);
   if(MI == NULL)
      return false;

   h = rpmmiNext(MI);
   if( h == NULL)
      return false;

   S = header.format("%{VERSION}");
   pkgVersion = S.c_str();
   S = header.format("%{RELEASE}");
   pkgRelease = S.c_str();


   header.getTag(RPMTAG_BASENAMES,FileNames);
   header.getTag(RPMTAG_DIRNAMES,DirNames);
   header.getTag(RPMTAG_DIRINDEXES,DirIndexes);
   header.getTag(RPMTAG_FILEFLAGS,FileFlags);
   
   for(int i = 0 ; i < DirIndexes.size(); i++)
   {
      if(FileFlags[i] & RPMFILE_CONFIG)
      {
	 string FilePath = string(DirNames[DirIndexes[i]]) + string(FileNames[i]);
	 FileList.push_back(FilePath);
      }
   }

   rpmmiFree(MI);
   rpmdbClose(DB);

   return true;
}

/*
bool pkgRPMCfgBackup::DeleteBckUPFiles()
{
   bool Ret = true;

   for(list<string>::iterator I = BckFileList.begin(); I != BckFileList.end(); I++)
   {
      if(unlink((*I).c_str()))
	 Ret = false;
   }

   return Ret;
}
*/

// vim:sts=3:sw=3
