#include <config.h>

#include <cstdio>
#include <cerrno>
#include <cstring>
#include <tr1/cinttypes>

#include <rpmio.h>
#include <rpmiotypes.h>
#include <rpmtypes.h>
#include <rpmlog.h>
#include <pkgio.h>
#include <rpmts.h>

int main(int argc, char *argv[])
{
	Header header = NULL;
	rpmRC rc;
	const char item[] = "Header";
	const char * msg = NULL;
	long count = 0;
	FD_t fd;
	if (argc != 2) {
		fprintf(stderr, "usage: countpkglist <pkglist>\n");
		exit(1);
	}
	fd = Fopen(argv[1], "r");
	if (fd == NULL) {
		fprintf(stderr, "error: can't open %s: %s",
			argv[1], strerror(errno));
		exit(1);
	}
	while ((rc = rpmpkgRead(item, fd, &header, &msg)) == RPMRC_OK) {
	    free(header);
	    count++;

	    switch (rc) {
		default:
		    rpmlog(RPMLOG_ERR, "%s: %s\n", item, msg);
		case RPMRC_NOTFOUND:
		    header = NULL;
		case RPMRC_OK:
		    break;
	    }
	    msg = (const char*)_free(msg);
	}
	
	Fclose(fd);
	printf("%ld\n", count);
	return 0;
}
